<?php // $Id$

/**
 * @file
 * Creating the admin pages for the Github widget pages.
 */

/**
 * Form building callback for the github widget settings page.
 */
function _github_widget_admin_settings() {
  $types = node_type_get_types();
  $final_types = array();
  foreach ($types as $key => $value) {
    $final_types[$key] = $value->name;
  }

  $form['github_widget_type_filters'] = array(
    '#type'          => 'checkboxes',
    '#title'         => t('Content types available'),
    '#default_value' => variable_get('github_widget_type_filters', array()),
    '#options'       => $final_types,
    '#description'   => t('Select the node types where the github widget should be shown.'),
  );

  $form['github_widget_project_info'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Show Github project information.'),
    '#default_value' => variable_get('github_widget_project_info', 1),
    '#description'   => t('Show the Github projectname, owner, link to readme.txt.'),
  );

  $form['github_widget_show_tagged_releases'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Show recommended releases (github tags).'),
    '#default_value' => variable_get('github_widget_show_tagged_releases', 1),
    '#description'   => t('Check this if you want to show the allowed releases of projects. This way only the project that apply to the naming conventions of Drupal will be shown. More information can be found here http://drupal.org/node/1015226'),
  );

  $form['github_widget_number_of_releases'] = array(
    '#type'          => 'textfield',
    '#size'          => 5,
    '#title'         => t('Show number of releases.'),
    '#default_value' => variable_get('github_widget_number_of_releases', 2),
    '#description'   => t('The amount of releases shown.'),
  );
  
  $form['github_widget_show_tagged_releases'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Show recommended releases (github tags).'),
    '#default_value' => variable_get('github_widget_show_tagged_releases', 1),
    '#description'   => t('Check this if you want to show the allowed releases of projects. This way only the project that apply to the naming conventions of Drupal will be shown. More information can be found here http://drupal.org/node/1015226'),
  );
  
  $form['github_widget_show_branches'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Show development releases (github branches).'),
    '#default_value' => variable_get('github_widget_show_branches', 0),
    '#description'   => t('This lists all the branches as development releases.'),
  );

  $form['github_widget_show_to_page'] = array(
    '#type'          => 'checkbox',
    '#title'         => t('Show the Github info on the bottom of the page.'),
    '#default_value' => variable_get('github_widget_show_to_page', 1),
    '#description'   => t('This module creates a block with all info (you have to enable it). Check if you want to show the Github information also on the end of a page.'),
  );

  $form['#validate'][] = '_github_widget_admin_settings_validate';
  return system_settings_form($form);
}

/**
 * Form validation handler for _github_widget_admin_settings().
 */
function _github_widget_admin_settings_validate($form, &$form_state) {
  if (!is_numeric($form_state['values']['github_widget_number_of_releases'])) {
    form_set_error('github_widget_number_of_releases', t('Please enter a valid number.'));
  }
}
